
/**
 * Write a description of class CheckerBoard here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

public class CheckerBoard extends ListItem
{
    /*** Instance Variables ***/
    public Checker[][] playingBoard;
    public int count;
    public int[] attackArray;                      // will be used for intermediate attacks
    public Stack attackStack; 
    public int beginningX;
    public int beginningY;
    public int endingX;
    public int endingY;
    
    /*** Constructors ***/
    public CheckerBoard(Checker[][] initial)
    {
        playingBoard = initial;
        //attackStack = new Stack();
        attackArray = new int[5];
        for (int i = 0; i < attackArray.length; i++)
        {
            attackArray[i] = 0;
        }
    }
    
    /*** Instance Methods ***/
    public int MMFinder()
    {
        int r = 0;
        int b = 0;
        for (int i = 0; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if (playingBoard[j][i].red)
                {
                    r++;
                }
                else if (playingBoard[j][i].black)
                {
                    b++;
                }
            }
        }
        if(endingX==0||endingX==7)
        {
            b = b-2;
        }
        
        return b - r;
    }
    
    public int conversion(int x, int y)
    {
        int temp = 4*y + 4;
     
        if(y % 2 ==0)
        {
            temp -= (7-x)/2;   
        }
        else
        {
            temp -= (6-x)/2;
        }     
        return temp;   
    }
 
    public int[] conversion(int i)
    {
        int x;
        int y;
        int temp [] = new int[2];
       
        y = (int)Math.ceil((double)i/4) - 1;

        if (y % 2 == 0)
        {
            if(i % 4 ==0)
            {
                x=7;
            }
            else
            {
                x = ((i % 4) *2 ) -1;
            }
        }
        else
        {
            if(i % 4 == 0)
            {
                x=6;
            }
            else
            {
                x = ((i % 4) *2) - 2;
            }    
        }
          
        temp[0] = x;
        temp[1] = y;
          
        return temp;
    }
    
    public void addToAttackArray(int open, int close)
    {
        int theMove = conversion(open, close);
        int i;
        for (i = 0; attackArray[i] != 0; i++)
        {
        }
        attackArray[i] = theMove;
    }
    
    public void attack(int startX, int startY, TreeNode parent)
    {
        boolean went = false;
        
        if (boundary(startX, startY, startX-2, startY+2))
        {
            if (playingBoard[startX-1][startY+1].black && playingBoard[startX-2][startY+2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX-2, startY+2);
                went = true;
                addToAttackArray(startX-2, startY+2);
                tempBoard.attack(startX-2, startY+2, parent);
            }
        }
        
        if (boundary(startX, startY, startX+2, startY+2))
        {
            if (playingBoard[startX+1][startY+1].black && playingBoard[startX+2][startY+2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX+2, startY+2);
                went = true;
                addToAttackArray(startX+2, startY+2);
                tempBoard.attack(startX+2, startY+2, parent);
            }
        }
        
        if (!went)
        {
            endingX = startX;
            endingY = startY;
            if(parent.links[0] == null)
               {
                   TreeNode newNode = new TreeNode(this);
                    parent.addChild(newNode);
               }
               else{
                   if(this.equals(parent.links[parent.numOfChildren-1].entry))
                   {
                   }
                       else{
                           TreeNode newNode = new TreeNode(this);
                           parent.addChild(newNode);
                           }
                   }  
        }
    }
    
    public void attackKing(int startX, int startY, TreeNode parent)
    {
        boolean went = false;
        
        if (boundary(startX, startY, startX-2, startY-2))
        {
            if (playingBoard[startX-1][startY-1].black && playingBoard[startX-2][startY-2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX-2, startY-2);
                went = true;
                addToAttackArray(startX-2, startY-2);
                tempBoard.attackKing(startX-2, startY-2, parent);
            }
        }
        
        if (boundary(startX, startY, startX+2, startY-2))
        {
            if (playingBoard[startX+1][startY-1].black && playingBoard[startX+2][startY-2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX+2, startY-2);
                went = true;
                addToAttackArray(startX+2, startY-2);
                tempBoard.attackKing(startX+2, startY-2, parent);
            }
        }
        
        if (boundary(startX, startY, startX-2, startY+2))
        {
            if (playingBoard[startX-1][startY+1].black && playingBoard[startX-2][startY+2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX-2, startY+2);
                went = true;
                addToAttackArray(startX-2, startY+2);
                tempBoard.attackKing(startX-2, startY+2, parent);
            }
        }
        
        if (boundary(startX, startY, startX+2, startY+2))
        {
            if (playingBoard[startX+1][startY+1].black && playingBoard[startX+2][startY+2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX+2, startY+2);
                went = true;
                addToAttackArray(startX+2, startY+2);
                tempBoard.attackKing(startX+2, startY+2, parent);
            }
        }
        
        if (!went)
        {
            endingX = startX;
            endingY = startY;
           if(parent.links[0] == null)
               {
                   TreeNode newNode = new TreeNode(this);
                    parent.addChild(newNode);
               }
               else{
                   if(this.equals(parent.links[parent.numOfChildren-1].entry))
                   {
                   }
                       else{
                           TreeNode newNode = new TreeNode(this);
                           parent.addChild(newNode);
                           }
                   }  
        }
    }

    public void attackBlack(int startX, int startY, TreeNode parent)
    {
        boolean went = false;
        
        if (boundary(startX, startY, startX-2, startY-2))
        {
            if (playingBoard[startX-1][startY-1].red && playingBoard[startX-2][startY-2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX-2, startY-2);
                went = true;
                addToAttackArray(startX-2, startY-2);
                tempBoard.attackBlack(startX-2, startY-2, parent);
            }
        }
        
        if (boundary(startX, startY, startX+2, startY-2))
        {
            if (playingBoard[startX+1][startY-1].red && playingBoard[startX+2][startY-2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX+2, startY-2);
                went = true;
                addToAttackArray(startX+2, startY-2);
                tempBoard.attackBlack(startX+2, startY-2, parent);
            }
        }
    
        if (!went)
        {
            endingX = startX;
            endingY = startY;
          if(parent.links[0] == null)
               {
                   TreeNode newNode = new TreeNode(this);
                    parent.addChild(newNode);
               }
               else{
                   if(this.equals(parent.links[parent.numOfChildren-1].entry))
                   {
                   }
                       else{
                           TreeNode newNode = new TreeNode(this);
                           parent.addChild(newNode);
                           }
                   }  
        }
        
    }
    
    public void attackBlackKing(int startX, int startY, TreeNode parent)
    {
        boolean went = false;
        
        if (boundary(startX, startY, startX-2, startY-2))
        {
            if (playingBoard[startX-1][startY-1].red && playingBoard[startX-2][startY-2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX-2, startY-2);
                went = true;
                addToAttackArray(startX-2, startY-2);
                tempBoard.attackBlackKing(startX-2, startY-2, parent);
            }
        }
        
        if (boundary(startX, startY, startX+2, startY-2))
        {
            if (playingBoard[startX+1][startY-1].red && playingBoard[startX+2][startY-2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX+2, startY-2);
                went = true;
                addToAttackArray(startX+2, startY-2);
                tempBoard.attackBlackKing(startX+2, startY-2, parent);
            }
        }
        
        if (boundary(startX, startY, startX-2, startY+2))
        {
            if (playingBoard[startX-1][startY+1].red && playingBoard[startX-2][startY+2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX-2, startY+2);
                went = true;
                addToAttackArray(startX-2, startY+2);
                tempBoard.attackBlackKing(startX-2, startY+2, parent);
            }
        }
        
        if (boundary(startX, startY, startX+2, startY+2))
        {
            if (playingBoard[startX+1][startY+1].red && playingBoard[startX+2][startY+2].empty)
            {
                CheckerBoard tempBoard = new CheckerBoard(this.copy(this.playingBoard));
                tempBoard.singleMove(startX, startY, startX+2, startY+2);
                went = true;
                addToAttackArray(startX+2, startY+2);
                tempBoard.attackBlackKing(startX+2, startY+2, parent);
            }
        }
        
        if (!went)
        {
            endingX = startX;
            endingY = startY;
            if(parent.links[0] == null)
               {
                   TreeNode newNode = new TreeNode(this);
                    parent.addChild(newNode);
               }
               else{
                   if(this.equals(parent.links[parent.numOfChildren-1].entry))
                   {
                   }
                       else{
                           TreeNode newNode = new TreeNode(this);
                           parent.addChild(newNode);
                           }
                   }       
        }
    }
    
    public boolean boundary(int startX, int startY, int endX, int endY)
    {
        if (startX > 7 || startX < 0 || startY > 7 || startY < 0 || endX > 7 || endX < 0 || endY > 7 || endY < 0)
        {
            return false;
        }
        else
        {
            return true;
        }
    }
    
    public CheckerBoard singleMove(int currentX, int currentY, int endX, int endY)
    {
        if (playingBoard[currentX][currentY].red == true)
        {
            playingBoard[currentX][currentY].red = false;
            playingBoard[currentX][currentY].empty = true;
            playingBoard[endX][endY].red = true;
            playingBoard[endX][endY].black = false;
            playingBoard[endX][endY].empty = false;
            if (playingBoard[currentX][currentY].king == true)
            {
                playingBoard[endX][endY].king = true;
                playingBoard[currentX][currentY].king = false;
            }
            else
            {
                if (endY == 7)
                {
                    playingBoard[endX][endY].king = true;
                }
                else
                {
                    playingBoard[endX][endY].king = false;
                }
            }
            if (Math.abs(currentX - endX) > 1)
            {
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].red = false;
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].black = false;
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].empty = true;
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].king = false;
            }
        }
        else if (playingBoard[currentX][currentY].black == true)
        {
            playingBoard[currentX][currentY].black = false;
            playingBoard[currentX][currentY].empty = true;
            playingBoard[endX][endY].black = true;
            playingBoard[endX][endY].red = false;
            playingBoard[endX][endY].empty = false;
            if (playingBoard[currentX][currentY].king == true)
            {
                playingBoard[endX][endY].king = true;
                playingBoard[currentX][currentY].king = false;
            }
            else
            {
                if (endY == 0)
                {
                    playingBoard[endX][endY].king = true;
                }
                else
                {
                    playingBoard[endX][endY].king = false;
                }
            }
            if (Math.abs(currentX - endX) > 1)
            {
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].red = false;
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].black = false;
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].empty = true;
                playingBoard[(currentX + endX)/2][(currentY + endY)/2].king = false;
            }
        }
        else
        {
            System.out.println("IMPOSSIBLE!!!");
            this.printState(true);
            int firstMove = conversion(currentX, currentY);
            int lastMove = conversion(endX, endY);
            System.out.println("This move could not be done:  " + firstMove + ", " + lastMove);
            System.out.println("***********THIS IS THE NAUGHTY ONE *******");
        }
        
        return this;
    }
    
    public boolean equivalent(CheckerBoard board2)
    {
        for (int i = 0; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if ((this.playingBoard[j][i].red && board2.playingBoard[j][i].red) || (!this.playingBoard[j][i].red && !board2.playingBoard[j][i].red))
                {
                    if ((this.playingBoard[j][i].black && board2.playingBoard[j][i].black) || (!this.playingBoard[j][i].black && !board2.playingBoard[j][i].black))
                    {
                        if ((this.playingBoard[j][i].king && board2.playingBoard[j][i].king) || (!this.playingBoard[j][i].king && !board2.playingBoard[j][i].king))
                        {
                            if ((this.playingBoard[j][i].empty && board2.playingBoard[j][i].empty) || (!this.playingBoard[j][i].empty && !board2.playingBoard[j][i].empty))
                            {
                                
                            }
                            else
                            {
                                return false;
                            }
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
        }
        return true;
    }
    public Checker[][] copy(Checker[][] pablo)
    {
        Checker[][] temp = new Checker[8][8];
        
        for(int j = 0; j < 8; j++)
        {
            for(int i = 0; i < 8; i++)
            {
              if (pablo[i][j].red)
              {
                  temp[i][j] = new Checker(true, false);
              }
              else if (pablo[i][j].black)
              {
                  temp[i][j] = new Checker(false, true);
              }
              else if (pablo[i][j].empty)
              {
                  temp[i][j] = new Checker(false, false);
              }
              
              if (pablo[i][j].king)
              {
                  temp[i][j].king = true;
              }
              else
              {
                  temp[i][j].king = false;
              }
            }
         }
        
        return temp;
    }
    public void printState(boolean first)
    {
        for (int i = 0; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                if (playingBoard[j][i].red)
                {
                    if(!first)
                    {
                     System.out.print("B");
                    }
                    else
                    {
                        System.out.print("R");
                     }
                 }    
                else if (playingBoard[j][i].black)
                {
                    if(!first)
                    {
                     System.out.print("R");
                    }
                    else
                    {
                        System.out.print("B");
                    }
                }
                else
                {
                    System.out.print(" ");
                }
                System.out.print(" ");
            }
            System.out.println("");
        }
    }
    
    public void printMoves(boolean first)
    {
       
       
               
        int firstMove = conversion(beginningX, beginningY);
        int lastMove = conversion(endingX, endingY);
        if(!first)
        {
            firstMove = 33 - firstMove;
            lastMove = 33 - lastMove;
        }
            
        System.out.print(firstMove + ", ");
        for (int i = 0; attackArray[i] != 0; i++)
        {
            System.out.print(attackArray[i] + ", ");
        }
        System.out.println(lastMove);
    }
}
