
/**
 * A home-made stack class using a linked list.
 * 
 * @author Mark Brown
 * @version Project 4
 */
public class Stack
{
    /*** Instance Variables ***/
    private LinkedList stackList;           // a new linked list is declared
    
    /*** Constructor ***/
    public Stack()
    {
        stackList = new LinkedList();
    }
    
    /*** Instance Methods ***/
    // Checks if the stack is empty
    public boolean isEmpty()
    {
        if (stackList.emptyList())
            return true;
        else
            return false;
    }
    
    // Adds a stackItem to the top of the stack.
    public void push(ListItem newItem)
    {
        ListNode newNode;
        newNode = new ListNode(newItem);
        stackList.addAtTail(newNode);
    }
    
    // Returns and removes the element from the top of the stack.
    public ListItem pop()
    {
        ListNode newNode;
        newNode = stackList.returnAndRemove();
        ListItem newItem;
        newItem = newNode.entry;
        return newItem;
    }
    
    // Only returns the top element of the stack.
    public ListItem peek()
    {
        ListNode newNode;
        newNode = stackList.returnTop();
        ListItem newItem;
        newItem = newNode.entry;
        return newItem;
    }
}
